<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "bing_place_stat".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "BingPlaceStat".
 *
 * Columns in table "bing_place_stat" available as properties of the model,
 * followed by relations of table "bing_place_stat" available as properties of the model.
 *
 * @property string $id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property string $store_id
 * @property string $start_date
 * @property string $end_date
 * @property integer $impressions
 * @property string $created_at
 *
 * @property Practice $practice
 * @property Provider $provider
 */
abstract class BaseBingPlaceStat extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'bing_place_stat';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'BingPlaceStat|BingPlaceStats', $n);
    }

    public static function representingColumn()
    {
        return 'store_id';
    }

    public function rules()
    {
        return array(
            array('provider_id, practice_id, impressions', 'numerical', 'integerOnly'=>true),
            array('store_id', 'length', 'max'=>200),
            array('start_date, end_date, created_at', 'safe'),
            array('provider_id, practice_id, store_id, start_date, end_date, impressions, created_at', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, practice_id, store_id, start_date, end_date, impressions, created_at', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => null,
            'practice_id' => null,
            'store_id' => Yii::t('app', 'Store'),
            'start_date' => Yii::t('app', 'Start Date'),
            'end_date' => Yii::t('app', 'End Date'),
            'impressions' => Yii::t('app', 'Impressions'),
            'created_at' => Yii::t('app', 'Created At'),
            'practice' => null,
            'provider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id, true);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('store_id', $this->store_id, true);
        $criteria->compare('start_date', $this->start_date, true);
        $criteria->compare('end_date', $this->end_date, true);
        $criteria->compare('impressions', $this->impressions);
        $criteria->compare('created_at', $this->created_at, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
